implementation module StdWindowDef


//	Version 1.0

//	Window definitions.


import	StdControlDef


::	Window c ls ps = Window Title (c ls ps) [WindowAttribute *(ls,ps)]
::	Dialog c ls ps = Dialog Title (c ls ps) [WindowAttribute *(ls,ps)]

::	WindowAttribute	ps																// Default:
//	Attributes for Windows and Dialogs:
	=	WindowId			Id														// system defined id
	|	WindowPos			ItemPos													// system dependent
	|	WindowIndex			Int														// open front-most
	|	WindowSize			Size													// screen size
	|	WindowHMargin		Int Int													// system dependent
	|	WindowVMargin		Int Int													// system dependent
	|	WindowItemSpace		Int Int													// system dependent
	|	WindowOk			Id														// no default (Custom)ButtonControl
	|	WindowCancel		Id														// no cancel  (Custom)ButtonControl
	|	WindowHide																	// initially visible
	|	WindowClose			(IOFunction ps)											// user can't close window
	|	WindowInit			[IdFun ps]												// no actions after opening window
//	Attributes for Windows only:	
	|	WindowSelectState	SelectState												// Able
	|	WindowLook			Look													// show system dependent background colour
	|	WindowViewDomain	ViewDomain												// {corner1=zero,corner2={x=max range,y=max range}}
	|	WindowOrigin		Point													// left top of picture domain
	|	WindowHScroll		ScrollFunction											// no horizontal scrolling
	|	WindowVScroll		ScrollFunction											// no vertical   scrolling
	|	WindowMinimumSize	Size													// system dependent
	|	WindowResize																// fixed size
	|	WindowActivate		(IOFunction ps)											// I
	|	WindowDeactivate	(IOFunction ps)											// I
	|	WindowMouse			MouseStateFilter    SelectState (MouseFunction    ps)	// no mouse input
	|	WindowKeyboard		KeyboardStateFilter SelectState (KeyboardFunction ps)	// no keyboard input
	| 	WindowCursor		CursorShape												// no change of cursor
::	CursorShape
	=	StandardCursor
	|	BusyCursor
	|	IBeamCursor
	|	CrossCursor
	|	FatCrossCursor
	|	ArrowCursor
	|	HiddenCursor

::	WindowType
	:==	String
