definition module windowdefaccess


//	Version 1.0

//	Access functions to (Window/Dialog)Definitions:

import	StdWindowDef


getWindowAttributes			:: !(Window c .ls .ps) -> (![WindowAttribute *(.ls,.ps)], !Window c .ls .ps)
getDialogAttributes			:: !(Dialog c .ls .ps) -> (![WindowAttribute *(.ls,.ps)], !Dialog c .ls .ps)
setWindowAttributes			:: ![WindowAttribute *(.ls,.ps)] !(Window c .ls .ps) -> Window c .ls .ps
setDialogAttributes			:: ![WindowAttribute *(.ls,.ps)] !(Dialog c .ls .ps) -> Dialog c .ls .ps

isAllWindowsAttribute		:: !(WindowAttribute .ps) -> Bool
isWindowOnlyAttribute		:: !(WindowAttribute .ps) -> Bool
isDialogOnlyAttribute		:: !(WindowAttribute .ps) -> Bool

iswindowid					:: !(WindowAttribute .ps) -> Bool
iswindowpos					:: !(WindowAttribute .ps) -> Bool
iswindowindex				:: !(WindowAttribute .ps) -> Bool
iswindowsize				:: !(WindowAttribute .ps) -> Bool
iswindowok					:: !(WindowAttribute .ps) -> Bool
iswindowcancel				:: !(WindowAttribute .ps) -> Bool
iswindowhmargin				:: !(WindowAttribute .ps) -> Bool
iswindowvmargin				:: !(WindowAttribute .ps) -> Bool
iswindowitemspace			:: !(WindowAttribute .ps) -> Bool
iswindowclose				:: !(WindowAttribute .ps) -> Bool
iswindowinit				:: !(WindowAttribute .ps) -> Bool
iswindowhide				:: !(WindowAttribute .ps) -> Bool
iswindowlook				:: !(WindowAttribute .ps) -> Bool
iswindowselectstate			:: !(WindowAttribute .ps) -> Bool
iswindowviewdomain			:: !(WindowAttribute .ps) -> Bool
iswindoworigin				:: !(WindowAttribute .ps) -> Bool
iswindowhscroll				:: !(WindowAttribute .ps) -> Bool
iswindowvscroll				:: !(WindowAttribute .ps) -> Bool
iswindowminimumsize			:: !(WindowAttribute .ps) -> Bool
iswindowresize				:: !(WindowAttribute .ps) -> Bool
iswindowactivate			:: !(WindowAttribute .ps) -> Bool
iswindowdeactivate			:: !(WindowAttribute .ps) -> Bool
iswindowmouse				:: !(WindowAttribute .ps) -> Bool
iswindowkeyboard			:: !(WindowAttribute .ps) -> Bool
iswindowcursor				:: !(WindowAttribute .ps) -> Bool

getwindowid					:: !(WindowAttribute .ps) -> Id
getwindowpos				:: !(WindowAttribute .ps) -> ItemPos
getwindowindex				:: !(WindowAttribute .ps) -> Int
getwindowsize				:: !(WindowAttribute .ps) -> Size
getwindowok					:: !(WindowAttribute .ps) -> Id
getwindowcancel				:: !(WindowAttribute .ps) -> Id
getwindowhmargin			:: !(WindowAttribute .ps) -> (Int,Int)
getwindowvmargin			:: !(WindowAttribute .ps) -> (Int,Int)
getwindowitemspace			:: !(WindowAttribute .ps) -> (Int,Int)
getwindowclosefunction		:: !(WindowAttribute .ps) -> IOFunction .ps
getwindowinit				:: !(WindowAttribute .ps) -> [IdFun .ps]
getwindowlook				:: !(WindowAttribute .ps) -> Look
getwindowselectstate		:: !(WindowAttribute .ps) -> SelectState
getwindowviewdomain			:: !(WindowAttribute .ps) -> ViewDomain
getwindoworigin				:: !(WindowAttribute .ps) -> Point
getwindowhscrollfunction	:: !(WindowAttribute .ps) -> ScrollFunction
getwindowvscrollfunction	:: !(WindowAttribute .ps) -> ScrollFunction
getwindowminimumsize		:: !(WindowAttribute .ps) -> Size
getwindowmouseinfo			:: !(WindowAttribute .ps) -> (MouseStateFilter,   SelectState,MouseFunction		.ps)
getwindowkeyboardinfo		:: !(WindowAttribute .ps) -> (KeyboardStateFilter,SelectState,KeyboardFunction	.ps)
getwindowactivatefunction	:: !(WindowAttribute .ps) -> IOFunction .ps
getwindowdeactivatefunction	:: !(WindowAttribute .ps) -> IOFunction .ps
getwindowcursor				:: !(WindowAttribute .ps) -> CursorShape
